#!/usr/local/bin/ruby
require "dir-compare"
require "ftools"

class DirSync < DirPairWalker
  def file_lt_file(s, t)
    File.cp(t, s)
  end

  def file_gt_file(s, t)
    File.cp(s, t)
  end

  def file_non(s, t)
    File.cp(s, t)
  end

  def non_file(s, t)
    File.cp(t, s)
  end

  def dir_non(s, t)
    File.mkpath(t)
  end

  def non_dir(s, t)
    File.mkpath(s)
  end
end

source, target = ARGV
visitor = DirSync.new
dc = DirCompare.new(visitor)
dc.run(source, target)
